###########################################################################/**
# @RdocClass NullSemaphore
#
# @title "The NullSemaphore class"
#
# \description{
#  @classhierarchy
#
#  A NullSemaphore is a class that fakes a semaphore, but it is not a
#  real semaphore because it is not synchronized with other processed,
#  i.e. it can always be aqcuired. 
# }
# 
# @synopsis
#
# \arguments{
#   \item{...}{Not used.}
# }
#
# \section{Fields and Methods}{
#  @allmethods "public"
# }
# 
# @author
#
# @keyword file
#*/########################################################################### 
setConstructorS3("NullSemaphore", function(...) {
  extend(AbstractSemaphore(), "NullSemaphore",
    .isAcquired = FALSE
  );
})


setMethodS3("isAcquired", "NullSemaphore", function(this, ...) {
  this$.isAcquired;
})


setMethodS3("release", "NullSemaphore", function(this, ...) {
  this$.isAcquired <- FALSE;
  invisible(isAcquired(this));
})


setMethodS3("tryAcquire", "NullSemaphore", function(this, ...) {
  this$.isAcquired <- TRUE;
  invisible(isAcquired(this));
})


############################################################################
# HISTORY:
# 2009-05-30
# o Created.
############################################################################ 
