
# Run an R process to wait for a semaphore, do some
# job that requires atomic transactions, release the
# semaphore, and so on.

# Server that controls the semaphore
host <- "127.0.0.1"

token <- SocketSemaphore(host, port=7777)
for (kk in 1:50) {
  if (acquire(token)) {
    cat("Client acquired semaphore.\n")
    Sys.sleep(runif(n=1, max=0.01))
    release(token)
    cat("Client released semaphore.\n")
    Sys.sleep(runif(n=1, max=0.1))
  }
}
