%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  SocketSemaphore.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

 \name{SocketSemaphore}
\docType{class}
\alias{SocketSemaphore}


 \title{The SocketSemaphore class}

 \description{
  Package:  R.filelocks \cr
\bold{Class SocketSemaphore}\cr

\code{\link[R.oo]{Object}}\cr
\code{~~|}\cr
\code{~~+--}\code{\link[R.filelocks]{AbstractSemaphore}}\cr
\code{~~~~~~~|}\cr
\code{~~~~~~~+--}\code{SocketSemaphore}\cr

\bold{Directly known subclasses:}\cr
\cr

public static class \bold{SocketSemaphore}\cr
extends \emph{\link[R.filelocks]{AbstractSemaphore}}\cr



  A SocketSemaphore is a class for acquiring a semphore from a server.
 }

 \usage{SocketSemaphore(host="127.0.0.1", port=7777, ...)}

 \arguments{
   \item{host, port}{The hostname and port number of the server.}
   \item{...}{Not used.}
 }

 \section{Fields and Methods}{
  \bold{Methods:}\cr
\tabular{rll}{
 \tab \code{finalize} \tab  -\cr
 \tab \code{isAcquired} \tab  -\cr
 \tab \code{release} \tab  -\cr
 \tab \code{tryAcquire} \tab  -\cr
}


 \bold{Methods inherited from AbstractSemaphore}:\cr
acquire, finalize, release, tryAcquire

 \bold{Methods inherited from Object}:\cr
$, $<-, [[, [[<-, as.character, attach, attachLocally, clearCache, clone, detach, equals, extend, finalize, gc, getEnvironment, getFields, getInstantiationTime, getStaticInstance, hasField, hashCode, ll, load, objectSize, print, save


 }

 \examples{\dontrun{
  
# Run a seperate R process providing a semaphore server
srv <- SocketSemaphoreServer(port=7777);
run(srv, verbose=-10);


  
# Run an R process to wait for a semaphore, do some
# job that requires atomic transactions, release the
# semaphore, and so on.

# Server that controls the semaphore
host <- "127.0.0.1"

token <- SocketSemaphore(host, port=7777)
for (kk in 1:50) {
  if (acquire(token)) {
    cat("Client acquired semaphore.\n")
    Sys.sleep(runif(n=1, max=0.01))
    release(token)
    cat("Client released semaphore.\n")
    Sys.sleep(runif(n=1, max=0.1))
  }
}

 }}

 \author{Henrik Bengtsson (\url{http://www.braju.com/R/})}


\keyword{classes}
\keyword{file}
